#line 1 "E:/Common/cross wire UART/AT89S52/uart.c"

sbit LCD_RS at P2_0_bit;
sbit LCD_RW at P2_1_bit;
sbit LCD_EN at P2_2_bit;
sbit LCD_D7 at P2_7_bit;
sbit LCD_D6 at P2_6_bit;
sbit LCD_D5 at P2_5_bit;
sbit LCD_D4 at P2_4_bit;



void ini_uart(void)
{
 TMOD=0X20;
 SCON=0X50;
 TH1=0XF3;
 TL1=0XF3;

 TCON.TR1=1;
}

void tx(unsigned char x)
{
 SBUF=x;
 while(SCON.TI==0);
 SCON.TI=0;
}

void send(const unsigned char* str)
{
while(*str)
tx(*str++);
}


void main()
{
 char i=1,rcvd;
 LCD_RW = 0;
 UART1_Init(9600);


 Lcd_Init();
 Delay_ms(100);
 Lcd_Out(1,1,"AT89s52 Ready");
 Lcd_Out(2,1,"Synchronizing");
 Delay_ms(500);
 Lcd_Cmd(_LCD_CLEAR);

 while(1)
 {
 Delay_ms(500);
 Lcd_Out(1,1,"Sending 'Y'");
 tx('Y');

 while(!UART1_Data_Ready());
 if (UART1_Data_Ready())
 {
 rcvd = UART1_Read();
 SCON.RI=0;

 }
 if(rcvd == 'Y')
 {
 Lcd_Out(1,1,"^_^");

 }
 else Lcd_Out(1,1,"?? ");
 }

}
