#line 1 "E:/Common/cross wire UART/PIC16F877/LCD_out-UART.c"
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D4 at RB4_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D7_Direction at TRISB7_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB4_bit;

unsigned short i,pos;
unsigned char rcvd;

void main()
{

 UART1_Init(9600);
 Lcd_Init();
 Delay_ms(100);
 Lcd_Out(1,1,"PIC16F877 Ready");
 Lcd_Out(2,1,"Synchronizing");
 Delay_ms(500);
 Lcd_Cmd(_LCD_CLEAR);
 i = 1;
 while(1)
 {

 if (UART1_Data_Ready())
 {
 rcvd = UART1_Read();

 }
 Lcd_Chr(2,1,rcvd);
 if(rcvd == 'Y')
 {
 Lcd_Out(1,1,"^_^");
 UART1_Write(rcvd);
 }
 else
 {
 Lcd_Out(1,1,"?? ");
 }
 }
 }
